program RS232;

var         line       :   integer;
            choice     :   char;
            message    :   string[255];
            command    :   string[25];
            track      :   string[2];
            index      :   string[2];
            minutes    :   string[2];
            seconds    :   string[2];
            frames     :   string[2];
            direction  :   string[2];
            level      :   string[10];
            receive    :   boolean;
            continue   :   boolean;
            max_ind    :   integer;
            ind        :   integer;
            value      :   integer;
            v          :   array[0..4] of byte;
            i          :   integer;
            high       :   byte;
            low        :   byte;
            check      :   integer;
            n          :   real;


procedure cur (on : boolean);

type  registers = record ax,bx,cx,dx,bp,si,di,ds,es,flags : integer end;
var   regs       :   registers;

begin
    with regs do
    begin
        ax := $300;
        bx := 0;
        intr($10,regs);
        if on then cx := cx and $DFFF
        else cx := cx or $2000;
        ax := $0100;
        intr($10,regs);
    end;
end;


begin
    port[$3fc] := 3;
    repeat;
    continue := true;
    clrscr;
    textcolor(15);
    writeln('a) start disc                             n) return to startcue');
    writeln('b) stop disc                              o) set volume level');
    writeln('c) pause                                  p) set varispeed value');
    writeln('d) play                                   q) autopause on');
    writeln('e) access to start of track               r) autopause off');
    writeln('f) set stopcue to end of track            s) start on modulation on');
    writeln('g) access to start of track/index         t) start on modulation off');
    writeln('h) set stopcue to end of track/index      u) stop on modulation on');
    writeln('i) access on absolute time                v) stop on modulation off');
    writeln('j) set stopcue to absolute time           w) fader start on');
    writeln('k) set dialing on absolute time           x) fader start off');
    writeln('l) jump real tracks                       y) audio mute on');
    writeln('m) clear stopcue                          z) audio mute off');
    writeln('-) reset cue points                       =) reset player');
    writeln('1) give status                            6) give current start/stop cue');
    writeln('2) give toc                               7) give cue 1,2,3');
    writeln('3) give disc-id                           8) give current time');
    writeln('4) give disc number                       9) give time (continue)');
    writeln('5) give isrc number');
    writeln('**********************************MENU*****************************************');
    repeat
    cur(false);
    receive := false;
    gotoxy(1,21);
    for line := 1 to 6 do
    begin
        delline;
    end;
    read(kbd,choice);
    case choice of
         'a' : begin    {start disc}
                   message := '@';
               end;
         'b' : begin    {stop disc}
                   message := 'A';
               end;
         'c' : begin    {pause}
                   message := 'B';
               end;
         'd' : begin    {play}
                   message := 'C';
               end;
         'e' : begin    {access to start of track}
                   cur(true);
                   write('track : ');
                   readln(track);
                   if length(track) = 0 then track := '00';
                   message := 'D'+ track;
                   cur(false);
               end;
         'f' : begin    {set stopcue to end of track}
                   cur(true);
                   write('track : ');
                   readln(track);
                   if length(track) = 0 then track := '00';
                   message := 'J' + track;
                   cur(false);
               end;
         'g' : begin    {access to start of track/index}
                   cur(true);
                   write('track : ');
                   readln(track);
                   if length(track) = 0 then track := '00';
                   if length(track) = 1 then track := '0' + track;
                   write('index : ');
                   readln(index);
                   if length(index) = 0 then index := '00';
                   if length(index) = 1 then index := '0' + index;
                   message := 'E' + track + index;
                   cur(false);
               end;
         'h' : begin    {set stopcue to end of track/index}
                   cur(true);
                   write('track : ');
                   readln(track);
                   if length(track) = 0 then track := '00';
                   if length(track) = 1 then track := '0' + track;
                   write('index : ');
                   readln(index);
                   if length(index) = 0 then index := '00';
                   if length(index) = 1 then index := '0' + index;
                   message := 'K' + track + index;
                   cur(false);
               end;
         'i' : begin    {access on absolute time}
                   cur(true);
                   write('minutes : ');
                   readln(minutes);
                   if length(minutes) = 0 then minutes := '00';
                   if length(minutes) = 1 then minutes := '0' + minutes;
                   write('seconds : ');
                   readln(seconds);
                   if length(seconds) = 0 then seconds := '00';
                   if length(seconds) = 1 then seconds := '0' + seconds;
                   write('frames  : ');
                   readln(frames);
                   if length(frames) = 0 then frames := '00';
                   if length(frames) = 1 then frames := '0' + frames;
                   message := 'F' + minutes + seconds + frames;
                   cur(false);
               end;
         'j' : begin     {set stopcue to absolute time}
                   cur(true);
                   write('minutes : ');
                   readln(minutes);
                   if length(minutes) = 0 then minutes := '00';
                   if length(minutes) = 1 then minutes := '0' + minutes;
                   write('seconds : ');
                   readln(seconds);
                   if length(seconds) = 0 then seconds := '00';
                   if length(seconds) = 1 then seconds := '0' + seconds;
                   write('frames  : ');
                   readln(frames);
                   if length(frames) = 0 then frames := '00';
                   if length(frames) = 1 then frames := '0' + frames;
                   message := 'I' + minutes + seconds + frames;
                   cur(false);
               end;
         'k' : begin     {set dialing on absolute time}
                   cur(true);
                   write('minutes : ');
                   readln(minutes);
                   if length(minutes) = 0 then minutes := '00';
                   if length(minutes) = 1 then minutes := '0' + minutes;
                   write('seconds : ');
                   readln(seconds);
                   if length(seconds) = 0 then seconds := '00';
                   if length(seconds) = 1 then seconds := '0' + seconds;
                   write('frames  : ');
                   readln(frames);
                   if length(frames) = 0 then frames := '00';
                   if length(frames) = 1 then frames := '0' + frames;
                   message := 'H' + minutes + seconds + frames;
                   cur(false);
               end;
         'l' : begin     {jump real tracks}
                   cur(true);
                   write('jump direction (0=forward, 1=reverse) : ');
                   readln(direction);
                   if length(direction) = 0 then direction := '00';
                   if length(direction) = 1 then direction := '0' + direction;
                   if direction <> '00' then direction := 'FF';
                   write('number of tracks <00,99> : ');
                   readln(track);
                   if length(track) = 0 then track := '00';
                   message := 'G' + direction + track;
                   cur(false);
               end;
         'm' : begin     {clear stopcue}
                   message := 'L';
               end;
         'n' : begin     {return to startcue}
                   message := 'T';
               end;
         'o' : begin     {set volume level}
                   cur(true);
                   write('volume-level <0-255> : ');
                   readln(level);
                   val(level,i,check);
                   if check = 0
                      then begin
                               if i > 255 then i:=255;
                               high:=i div 16; if high>9 then high:=high+55 else high:=high+48;
                               low:=i mod 16; if low>9 then low:=low+55 else low:=low+48;
                               message := 'R' + chr(high) + chr(low)
                           end
                      else message := 'RXX';
                   cur(false);
               end;
         'p' : begin     {set varispeed value}
                   cur(true);
                   write('varispeed-value <-10.0 - 10.0> : ');
                   readln(level);
                   val(level,n,check);
                   if check <> 0
                      then begin  {input not good}
                               message := 'SXXX'
                           end
                      else begin
                               if n >= 0
                                  then begin  {input is positive}
                                           if n >= 10
                                              then message := 'S0A'
                                              else begin
                                                       i := pos('.',level);
                                                       if i = 0
                                                          then message := 'S' + chr(trunc(n) + 48);
                                                       if i = 1
                                                          then begin
                                                                   if length(level) > 1
                                                                      then message := 'S00' + level[2]
                                                                      else message := 'SXXX'
                                                               end;
                                                       if i > 1
                                                          then begin
                                                                   message := 'S0' + chr(trunc(n) + 48);
                                                                   if i < length(level)
                                                                      then message := message + level[i+1]
                                                               end
                                                   end
                                       end
                                  else begin  {input is negative}
                                           if n <= -10
                                              then message := 'SF6'
                                              else begin
                                                       if n > -1
                                                          then message := 'S0' {value <0 and >-1 can't be given}
                                                          else begin
                                                                   i := pos('.',level);
                                                                   if trunc(n) >= -6
                                                                      then message := 'SF' + chr(trunc(n) + 71)
                                                                      else message := 'SF' + chr(trunc(n) + 64);
                                                                   if (i > 1) and (i < length(level))
                                                                      then message := message + level[i+1];
                                                               end
                                                   end
                                       end
                           end;
                   cur(false);
               end;
         'q' : begin     {autopause on}
                   message := 'X';
               end;
         'r' : begin     {autopause off}
                   message := 'Y';
               end;
         's' : begin     {start on modulation on}
                   message := 'M';
               end;
         't' : begin     {start on modulation off}
                   message := 'N';
               end;
         'u' : begin     {stop on modulation on}
                   message := 'O';
               end;
         'v' : begin     {stop on modulation off}
                   message := 'P';
               end;
         'w' : begin     {fader start on}
                   message := 'U';
               end;
         'x' : begin     {fader start off}
                   message := 'V';
               end;
         'y' : begin     {audio mute on}
                   message := 'Z';
               end;
         'z' : begin     {audio mute off}
                   message := '[';
               end;
         '-' : begin     {reset cue points}
                   message := 'Q';
               end;
         '=' : begin     {reset player}
                   message := '!';
               end;
         '1' : begin     {give status}
                   receive := true;
                   message := '"@';
                   command := 'status';
                end;
          '2' : begin    {give toc}
                    receive := true;
                    message := '"B';
                    command := 'toc';
                end;
          '3' : begin    {give disc id}
                    receive := true;
                    message := '"E';
                    command := 'disc-id';
                end;
          '4' : begin    {give disc number}
                    receive := true;
                    message := '"C';
                    command := 'disc-nr';
                end;
          '5' : begin    {give isrc number}
                    receive := true;
                    message := '"D';
                    command := 'isrc-nr';
                end;
          '6' : begin    {give current start/stop cue}
                    receive := true;
                    message := '"F';
                    command := 'current-cue'
                end;
          '7' : begin    {give cue 1,2,3}
                    receive := true;
                    message := '"G';
                    command := 'cue1,2,3';
                end;
          '8' : begin    {give current time}
                    receive := true;
                    message := '"A';
                    command := 'time';
                end;
          '9' : begin    {give time (continue)}
                    clrscr;
                    receive := true;
                    gotoxy(25,1);
                    textcolor(15);
                    write('***PRESENT-TIME***');
                    gotoxy(25,25);
                    write('*** press any key to quit ***');
                    continue := true;
                    textcolor(7);
                    gotoxy(25,12);
                    write('track : ');
                    gotoxy(25,13);
                    write('index : ');
                    gotoxy(25,14);
                    write('relative-time : ');
                    gotoxy(25,15);
                    write('absolute-time : ');
                    while continue do
                    begin
                        writeln(aux,'"A');
                        readln(aux,message);
                        if keypressed then continue := false;
                        gotoxy(33,12);
                        write(copy(message,1,2));
                        gotoxy(33,13);
                        write(copy(message,3,2));
                        gotoxy(41,14);
                        write(copy(message,5,2),':',copy(message,7,2));
                        gotoxy(41,15);
                        write(copy(message,11,2),':',copy(message,13,2));
                    end;
                    cur(true);
                end;
           else begin   {transmit a nonsens message for illegal key}
                    message := '~';
                end;
    end;  {end case}
    writeln(aux,message);
    if not receive then
    begin
        readln(aux,message);
    end;
    until receive;
    clrscr;
    readln (aux,message);
    max_ind := (length(message));
    if command = 'cue1,2,3' then
    begin
        textcolor(15);
        gotoxy(25,1);
        write('***CUE (1,2,3)***');
        gotoxy(10,10);
        write('***CUE-01***');
        gotoxy(30,10);
        write('***CUE-02***');
        gotoxy(50,10);
        write('***CUE-03***');
        textcolor(7);
        gotoxy(10,12);
        write('track : ',copy(message,1,2));
        gotoxy(10,13);
        write('index : ',copy(message,3,2));
        gotoxy(10,14);
        write('time  :',copy(message,5,2),':',copy(message,7,2),':',
               copy(message,9,2));
        gotoxy(30,12);
        write('track : ',copy(message,13,2));
        gotoxy(30,13);
        write('index : ',copy(message,15,2));
        gotoxy(30,14);
        write('time  :',copy(message,17,2),':',copy(message,19,2),':',
               copy(message,21,2));
        gotoxy(50,12);
        write('track : ',copy(message,25,2));
        gotoxy(50,13);
        write('index : ',copy(message,27,2));
        gotoxy(50,14);
        write('time  :',copy(message,29,2),':',copy(message,31,2),':',
               copy(message,33,2));
    end;
    if command = 'current-cue' then
    begin
        textcolor(15);
        gotoxy(25,1);
        write('***CURRENT-CUE***');
        gotoxy(10,10);
        write('***START***');
        gotoxy(45,10);
        write('***STOP***');
        textcolor(7);
        gotoxy(10,12);
        write('track : ',copy(message,1,2));
        gotoxy(10,13);
        write('index : ',copy(message,3,2));
        gotoxy(10,14);
        write('time  : ',copy(message,5,2),':',copy(message,7,2),':',
              copy(message,9,2));
        gotoxy(45,12);
        write('track : ',copy(message,11,2));
        gotoxy(45,13);
        write('index : ',copy(message,13,2));
        gotoxy(45,14);
        write('time  : ',copy(message,15,2),':',copy(message,17,2),':',
               copy(message,19,2));
    end;
    if command = 'toc' then
    begin
        textcolor(15);
        gotoxy(25,1);
        writeln('***TABLE OF CONTENTS***');
        gotoxy(29,4);
        writeln('TR  MI  SE  FR');
        textcolor(7);
        ind := 1;
        while ind <= (max_ind - 7) do
        begin
            writeln('                            ',
                    copy(message,ind,2),'  ',copy(message,ind + 2,2),'  ',
                    copy(message,ind + 4,2),'  ',copy(message,ind + 6,2));
            ind := ind + 8;
        end;
    end;
    if command = 'status' then
    begin
        textcolor(15);
        gotoxy(30,1);
        write('***STATUS***');
        writeln;
        writeln;
        writeln;
        textcolor(7);
        for i := 1 to 4 do
        begin
            if (ord(copy(message,i,1)) > 64) and (ord(copy(message,i,1)) < 71)
            then
            begin
                v[i] := ord(copy(message,i,1)) - 55;
            end
            else
            begin
                v[i] := ord(copy(message,i,1)) - 48;
           end;
        end;
        if (v[1] and 1) = 1 then writeln('- fader open');
        if (v[1] and 1) = 0 then writeln('- fader closed');
        if (v[1] and 2) = 2 then writeln('- player in local mode');
        if (v[1] and 4) = 4 then writeln('- index found');
        if (v[1] and 8) = 8 then writeln('- no audio disc');
        if (v[2] and 1) = 1 then writeln('- laser on start cue');
        if (v[2] and 2) = 2 then writeln('- laser on stop cue');
        if (v[2] and 4) = 4 then writeln('- disc loaded in player');
        if (v[2] and 8) = 8 then writeln('- toc loaded');
        if (v[3] and 1) = 1 then writeln('- player is pausing');
        if (v[3] and 2) = 2 then writeln('- lid is open');
        if (v[3] and 2) = 0 then writeln('- lid is closed');
        if (v[4] and 1) = 1 then writeln('- player drive is stopped');
        if (v[4] and 2) = 2 then writeln('- player is starting up');
        if (v[4] and 4) = 4 then writeln('- player is playing');
        if (v[4] and 8) = 8 then writeln('- player searching for position');
    end;
    if command = 'time' then
    begin
        textcolor(15);
        gotoxy(25,1);
        write('***PRESENT-TIME***');
        textcolor(7);
        gotoxy(25,12);
        write('track : ',copy(message,1,2));
        gotoxy(25,13);
        write('index : ',copy(message,3,2));
        gotoxy(25,14);
        write('relative-time : ',copy(message,5,2),':',copy(message,7,2),':',
               copy(message,9,2));
        gotoxy(25,15);
        write('absolute-time : ',copy(message,11,2),':',copy(message,13,2),
              ':',copy(message,15,2));
    end;
    if command = 'disc-nr' then
    begin
        textcolor(15);
        gotoxy(25,1);
        write('***DISC-NUMBER***');
        textcolor(7);
        gotoxy(28,10);
        write(message);
    end;
    if command = 'disc-id' then
    begin
        textcolor(15);
        gotoxy(25,1);
        write('***DISC-ID***');
        textcolor(7);
        gotoxy(28,10);
        write(message);
    end;
    if command = 'isrc-nr' then
    begin
        textcolor(15);
        gotoxy(25,1);
        write('***ISRC-NUMBER***');
        textcolor(7);
        gotoxy(28,10);
        write(message);
    end;
    if continue then
    begin
        textcolor(15);
        gotoxy(25,24);
        write('*** CONTINUE <Y/N> ***');
        read(kbd,choice);
    end;
    until (choice = 'n') or (choice = 'N');
  cur(true);
  end.